<script lang="ts">
	import showdown from 'showdown';
	import { template } from '../template';
	import { nl } from '../nl';
	import { onMount } from 'svelte';
	import { browser } from '$app/env';

	type ElType =
		| 'div'
		| 'table'
		| 'h1'
		| 'h2'
		| 'h3'
		| 'p'
		| 'ol'
		| 'ul'
		| 'code'
		| 'blockquote'
		| 'a'
		| 'hr';

	let textareaVal = ''; // nl;
	let htmlFromMarkdown: string;
	let wrappedResult: string;

	showdown.setOption('tables', true);
	const converter = new showdown.Converter();
	const replacements = [
		{ tag: 'table' as ElType, code: template.table },
		{ tag: 'h1' as ElType, code: template.h1 },
		{ tag: 'h2' as ElType, code: template.h2 },
		{ tag: 'h3' as ElType, code: template.h3 },
		{ tag: 'blockquote' as ElType, code: template.blockquote },
		{ tag: 'p' as ElType, code: template.paragraph },
		{ tag: 'ol' as ElType, code: template.paragraph },
		{ tag: 'ul' as ElType, code: template.paragraph },
		{ tag: 'code' as ElType, code: template.code },
		{ tag: 'hr' as ElType, code: template.line },
		{ tag: 'a' as ElType, code: null }
	];

	/* onMount(() => {
		if (browser) {
			submit();
		}
	}); */

	function replaceAllElements(elType: ElType, templatePiece: string, html: Document) {
		html.querySelectorAll(elType).forEach((el: HTMLElement) => {
			if ('a' === elType) {
				el.outerHTML = el.outerHTML.replace(/<a href="/gi, '<a style="color:#00D0FF;" href="');
			} else {
				const innerText = el.innerText;
				const innerHTML = el.innerHTML;
				const outerHTML = el.outerHTML;
				let replaceSlotWith: string;
				if (['ol', 'ul'].includes(elType)) {
					replaceSlotWith = outerHTML;
				} else if (['blockquote'].includes(elType)) {
					replaceSlotWith = innerText;
				} else if ('table' === elType) {
					replaceSlotWith = innerHTML
						.replace(/<td>/gi, '<td style="color:#ffffff;">')
						.replace(/<th>/gi, '<th style="color:#ffffff;">');
				} else {
					replaceSlotWith = innerHTML;
				}

				const replacedBlock = templatePiece.replace('[SLOT]', replaceSlotWith);
				el.outerHTML = replacedBlock;
			}
		});
	}

	function submit() {
		htmlFromMarkdown = converter.makeHtml(textareaVal);
		const htmlEl: Document = new DOMParser().parseFromString(htmlFromMarkdown, 'text/html');

		replacements.forEach((replacement: { tag: ElType; code: string }) => {
			replaceAllElements(replacement.tag, replacement.code, htmlEl);
		});

		const htmlString = htmlEl.body.innerHTML;
		const content = template.heroImage + htmlString + template.line + template.footer;
		wrappedResult = (template.html as any).replace('[SLOT]', content);
	}

	function copyToClipboard() {
		navigator.clipboard.writeText(wrappedResult).then(
			function () {
				alert('Copying to clipboard was successful!');
			},
			function (err) {
				alert('Async: Could not copy text: ' + err);
			}
		);
	}
</script>

<div class="app">
	<div class="left">
		<textarea name="" id="" cols="30" rows="10" bind:value={textareaVal} />

		<button on:click={submit}>Convert</button>
	</div>
	<div class="right">
		<iframe class="iframe" srcdoc={wrappedResult} frameborder="0" />
		<button on:click={copyToClipboard}>Copy HTML e-mail to clipboard</button>
	</div>
</div>

<style type="text/scss">
	.app {
		width: 100vw;
		height: 100vh;
		display: flex;
	}

	textarea {
		width: 100%;
		height: calc(100vh - 5.1rem);
		padding: 1rem;
	}

	.left {
		padding: 1rem;

		button {
			width: 100%;
			background-color: #2d3445;
			border-radius: 0.5rem;
			color: #fff;
			border: 0;
			margin-block: 1rem;
			font-size: 1.1rem;
			line-height: 1;
			padding: 0.5rem;
		}
	}

	.right {
		position: relative;

		button {
			display: inline-block;
			background-color: #fff;
			border-radius: 0.5rem;
			color: #2d3445;
			border: 0;
			font-size: 0.8rem;
			line-height: 1;
			padding: 0.5rem;
			position: absolute;
			right: 1rem;
			top: 1rem;
			cursor: pointer;
		}
	}

	.left,
	.right {
		flex: 1 1 50%;
	}
	.iframe {
		width: 100%;
		height: 100vh;
	}
</style>
